;
;   bootstrap code
;

.text

BOOTSTRAP       = START_ADDRESS
BOOTSTRAP_SIZE  = (bootstrap_end-bootstrap)


BIGMAC          = $0550
BIGMAC_OFFSET   = (BOOTSTRAP+BOOTSTRAP_SIZE)
BIGMAC_SIZE     = (bigmac_end-bigmac)

LOADER          = $6D00
LOADER_OFFSET   = (BOOTSTRAP+BOOTSTRAP_SIZE+BIGMAC_SIZE)
LOADER_SIZE     = (ldr_end-ldr)

MONITOR         = $9000
MONITOR_OFFSET  = (BOOTSTRAP+BOOTSTRAP_SIZE+BIGMAC_SIZE+LOADER_SIZE)
MONITOR_SIZE    = (monitor_end-monitor)

*       = BOOTSTRAP

bootstrap
.(
        ldx #0
        ldy #>LOADER_SIZE
loop
        beq rest
        jsr bootstrap_move
        dey
        bne loop
rest
        ldx #<LOADER_SIZE
        jsr bootstrap_move

        jmp LOADER
.)

bootstrap_move
bootstrap_move_src_lo  = (*+1)
bootstrap_move_src_hi  = (*+2)
        lda LOADER_OFFSET
        inc bootstrap_move_src_lo
        bne bootstrap_move_src_skip
        inc bootstrap_move_src_hi
bootstrap_move_src_skip

bootstrap_move_dst_lo  = (*+1)
bootstrap_move_dst_hi  = (*+2)
        sta LOADER
        inc bootstrap_move_dst_lo
        bne bootstrap_move_dst_skip
        inc bootstrap_move_dst_hi
bootstrap_move_dst_skip

        dex
        bne bootstrap_move
        rts

bootstrap_pad = *

        .dsb (BIGMAC - *)
bootstrap_end

#echo ======================================================
#echo Reserved:
#print (BIGMAC-bootstrap_pad)
#echo ======================================================
